#include <iostream>
#include <cstdio>
#include "testlib.h"

using namespace std;

int up[(int)1e4 + 3], down[(int)1e4 + 3];

int main(int argc, char *argv[]) {
	registerGen(argc, argv, 1);

    int n = atoi(argv[3]);
    int m = atoi(argv[4]);

    int n1 = atoi(argv[1]), m1 = atoi(argv[2]);

    fill(up, up + (int)1e4 + 2, n);
    fill(down, down + (int)1e4 + 2, n);

    int sty = rnd.next(0, n - n1);
    for (int stx = 0; stx < m - m1; stx++) {
        int i = stx;
        up[i] = sty, down[i] = n - sty - n1;
        for (int j = stx; j < stx + m1; j++) {
            up[i] = min(up[i], sty);
            down[i] = min(down[i], n - sty - n1);
        }
        int x = rnd.next(0, 3);
        if (stx + 1 == m - m1) {
            fill(up + i, up + m, up[i]);
            fill(down + i, down + m, down[i]);
        }
        if (x == 0) {
            if (sty) sty--;
            else sty++;
        }
        if (x == 1) {
            if (sty != n - n1) sty++;
            else sty--;
        }
    }

    cout << n << ' ' << m << endl;
    for (int i = 0; i < m; i++) {
    	cout << up[i];
    	if (i + 1 != m) cout << ' ';
    }
    cout << endl;

    for (int i = 0; i < m; i++) {
    	cout << down[i];
    	if (i + 1 != m) cout << ' ';
    }
    cout << endl;
    return 0;
 }