#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#else
#  define cerr __get_ce
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<int, int> pii;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
mt19937 tw(9450189);
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<char>> field(n, vector<char>(m));
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < m; ++j) {
			field[i][j] = s[j];
		}
	}

	if (n > m) {
		vector<vector<char>> field2(m, vector<char>(n));
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				field2[j][i] = field[i][j];
			}
		}
		swap(field, field2);
		swap(n, m);
	}

	vector<vector<pii>> states;

	vector<pii> cur;
	vector<bool> used(n);
	unordered_map<ull, int> ind_state;
	function<void(int)> rec = [&](int pos) {
		if (pos == n) {
			for (int i = 0; i < szof(cur) - 1; ++i) {
				assert(cur[i].ff < cur[i + 1].ff);
			}
			states.push_back(cur);
			ull h = 0;
			for (auto p : cur) {
				h = h * 23 + p.ff + 1;
				h = h * 23 + p.ss + 1;
			}
			ind_state[h] = szof(states) - 1;
			return;
		}
		rec(pos + 1);
		if (!used[pos]) {
			for (int i = pos + 1; i < n; ++i) {
				if (used[i]) {
					break;
				}
				cur.push_back({pos, i});
				used[i] = true;
				rec(pos + 1);
				used[i] = false;
				cur.pop_back();
			}
		}
	};
	
	rec(0);

	assert(szof(states) == szof(ind_state));

	vector<vector<int>> ends;
	for (auto& v : states) {
		ends.push_back({});
		for (auto p : v) {
			ends.back().push_back(p.ff);
			ends.back().push_back(p.ss);
		}
	}

	// cerr << szof(states) << "\n";

	vector<vector<tuple<int, int, int>>> go(szof(states));

	vector<int> neibs(n);
	vector<vector<int>> graph(n, vector<int>(2));

	int cnt = 0;
	for (int i = 0; i < szof(states); ++i) {
		for (int j = 0; j < 1 << (n - 1); ++j) {
			bool fl = true;
			for (int p : ends[i]) {
				if (0 < p && p < n - 1) {
					if ((j & (1 << (p - 1))) && (j & (1 << p))) {
						fl = false;
						break;
					}
				}
			}
			if (!fl) {
				continue;
			}

			cnt++;

			fill(neibs.begin(), neibs.end(), 0);

			for (int k = 0; k < n - 1; ++k) {
				if (j & (1 << k)) {
					graph[k][neibs[k]++] = k + 1;
					graph[k + 1][neibs[k + 1]++] = k;
				}
			}

			for (pii p : states[i]) {
				graph[p.ff][neibs[p.ff]++] = p.ss;
				graph[p.ss][neibs[p.ss]++] = p.ff;
			}

			fill(used.begin(), used.end(), 0);

			ull h = 0;
			for (int k = 0; k < n; ++k) {
				if (!used[k] && neibs[k] == 1) {
					int cur = k;
					int prev = -1;
					do {
						int next = graph[cur][0];
						if (next == prev) {
							next = graph[cur][1];
						}
						prev = cur;
						cur = next;
						used[cur] = true;
					} while (neibs[cur] == 2);
					h = h * 23 + k + 1;
					h = h * 23 + cur + 1;
				}
			}

			int add = 0;
			for (int k = 0; k < n; ++k) {
				if (!used[k] && neibs[k] == 2) {
					int cur = k;
					int prev = -1;
					do {
						int next = graph[cur][0];
						if (next == prev) {
							next = graph[cur][1];
						}
						prev = cur;
						cur = next;
						used[cur] = true;
					} while (cur != k);
					++add;
				}
			}

			// assert(is_sorted(next_state.begin(), next_state.end()));
			go[i].push_back({j, ind_state[h], add});
		}
	}

	// cerr << cnt << endl;

	// cerr << "here " << clock() * 1000 / CLOCKS_PER_SEC << endl;

	vector<pair<int, ll>> d(szof(states), {-INF, 0});
	d[0] = {0, 1};
	vector<pair<int, ll>> next(szof(states));

	vector<bool> ok_mask(1 << (n - 1));

	for (int i = 0; i < m; ++i) {
		fill(next.begin(), next.end(), make_pair(-INF, 0));
		for (int j = 0; j < 1 << (n - 1); ++j) {
			ok_mask[j] = true;
			for (int k = 0; k < n - 1; ++k) {
				if ((j & (1 << k)) && field[k][i] != field[k + 1][i]) {
					ok_mask[j] = false;
					break;
				}
			}
		}
		for (int j = 0; j < szof(states); ++j) {
			if (!i && j) {
				continue;
			}
			bool ok = true;
			for (int p : ends[j]) {
				if (field[p][i - 1] != field[p][i]) {
					ok = false;
					break;
				}
			}
			if (!ok) {
				continue;
			}
			for (auto [mask, st, add] : go[j]) {
				if (ok_mask[mask]) {
					//next[st] = max(next[st], d[j] + add);
					if (next[st].ff < d[j].ff + add) {
						next[st] = {d[j].ff + add, d[j].ss};
					} else if (next[st].ff == d[j].ff + add) {
						next[st].ss += d[j].ss;
						if (next[st].ss > INFL) {
							next[st].ss = INFL;
						}
					}
				}
			}
		}

		swap(next, d);
	}

	const ll threshold = 1000000000000000000ll;

	cout << d[0].ff << " ";
	if (d[0].ss > threshold) {
		cout << "-1\n";
	} else {
		cout << d[0].ss << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
