#include <bits/stdc++.h>

int main() {
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<int>> pixels(n, std::vector<int>(m, -1));
    for (int i = 0; i < n; i++) {
        std::string s;
        std::cin >> s;
        for (int j = 0; j < m; j++) {
            if (s[j] == '.') {
                pixels[i][j] = 0;
            } else if (s[j] == 'R') {
                pixels[i][j] = 1;
            } else if (s[j] == 'G') {
                pixels[i][j] = 2;
            } else {
                pixels[i][j] = 4;
            }
        }
    }
    bool ok = true;
    for (int i = 0; i < n; i++) {
        std::string s;
        std::cin >> s;
        for (int j = 0; j < m; j++) {
            int mask = s[j] - '0';
            if ((pixels[i][j] & mask) != pixels[i][j]) {
                ok = false;
            }
        }
    }
    std::cout << (ok ? "correct\n" : "incorrect\n");
    return 0;
}
