#include <bits/stdc++.h>
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

const int dd = (int)1e6 + 7;
const int maxM = 4;
const int sz = 82;

int type[sz][maxM];
ll dp1[sz], dp2[sz];

int open[sz][maxM];
int close[sz][maxM];

int n, m;
	
int cur[7];
int cnt;

void gen(int v, int num) {
	if (v == m) {
		for (int i = 0; i < m; i++) type[num][i] = cur[i];
		
		int p = 1;
		for (int i = m - 1; i >= 0; i--) {
			if (cur[i] == 0) open[num][i] = num + p;
			if (cur[i] == 1) close[num][i] = num + p;
			p *= 3;
		}
		cnt++;	
	} else {
		cur[v] = 0;
		gen(v + 1, num * 3);
		
		cur[v] = 1;
		gen(v + 1, num * 3 + 1);
		
		cur[v] = 2;
		gen(v + 1, num * 3 + 2);
	}
}

void upd(ll &a, ll b) {
	if (a > b) a = b;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> m;
	
	vector<ll> a(n), l(m), r(m);
	for (int i = 0; i < n; i++) cin >> a[i];
	for (int i = 0; i < m; i++) {
		cin >> l[i] >> r[i];
		l[i]--;
	}
	
	gen(0, 0);
	
	fill(dp1, dp1 + cnt, (ll)1e18);
	fill(dp2, dp2 + cnt, (ll)1e18);
	
	dp1[0] = 0;	
	for (int i = 0; i <= n; i++) {
		for (int msk = 0; msk < cnt; msk++) if (dp1[msk] != (ll)1e18) {
			ll cur = dp1[msk];
			for (int j = 0; j < m; j++) {
				if (type[msk][j] == 0 && l[j] <= i && i < r[j]) {
					upd(dp1[open[msk][j]], cur);
				}
				if (type[msk][j] == 1 && l[j] < i && i <= r[j]) {
					upd(dp1[close[msk][j]], cur);
				}
			}
			
			int can = 1;
			ll cost = m * a[i];
			for (int j = m - 1; j >= 0; j--) {
				if (type[msk][j] == 1 && (i < l[j] || i >= r[j]))
					can = 0;
				if (type[msk][j] == 1 && l[j] <= i && i < r[j]) cost = j * a[i];
			}
			if (can) upd(dp2[msk], cur + cost);
		}
		if (i == n) break;
		for (int msk = 0; msk < cnt; msk++) {
			dp1[msk] = dp2[msk], dp2[msk] = (ll)1e18;
		}
	}
	
	ll ans = (ll)1e18;
	for (int msk = 0; msk < cnt; msk++) {
		int can = 1;
		for (int j = 0; j < m; j++) if (type[msk][j] == 1) can = 0;
		if (can) upd(ans, dp1[msk]);
	}
	cout << ans << "\n";
	return 0;
}