#include<bits\stdc++.h>
using namespace std;

vector<int> min_depth; 
vector<int> ans; 
vector<vector<int>> g;
vector<bool> used;

int dfs(int v, int curd, int root)
{
    used[v] = true;
    if (g[v].size() == 1 && v != root) {
        return curd;
    }
    int res = 2 * g.size();
    for (int u : g[v])
        if (!used[u])
            res = min(res, dfs(u, curd + 1, root));
    return res;
}


int main()
{
    int n;
    cin >> n;
    g.resize(n);
    for (int i = 0; i < n - 1; i++)
    {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    int ans = 2 * n;
    for (int i = 0; i < n; i++)
    {
        if (g[i].size() != 1)
            continue;
        used.assign(n, false);
        int cur = dfs(i, 0, i);
        ans = min(ans, cur);
    }
    cout << ans << endl;            
    return 0;
}