#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

const int MAXSZ = 160;
const int MAXT = 20;

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	assert(argc >= 3);

	int n0 = atoi(argv[1]);
	int m0 = atoi(argv[2]);

	vector<pii> szs;

	for (int i = 1; i * n0 <= MAXSZ; ++i) {
		int j = MAXSZ / (i * n0) / m0;
		if (j) {
			szs.push_back({i, j});
			if (szof(szs) == MAXT) {
				break;
			}
		}
	}

	cout << szof(szs) << "\n";

	vector<pii> shifts = {{-1, 0}, {0, -1}};

	for (auto [n1, m1] : szs) {
		cout << n1 * n0 << " " << m1 * m0 << "\n";
		vector<vector<char>> field(n1, vector<char>(m1));
		for (int i = 0; i < n1; ++i) {
			for (int j = 0; j < m1; ++j) {
				while (true) {
					char c = 'a' + rnd.next(0, 25);
					bool ok = true;
					for (auto [dx, dy] : shifts) {
						int nx = i + dx;
						int ny = j + dy;
						if (0 <= nx && 0 <= ny && field[nx][ny] == c) {
							ok = false;
							break;
						}
					}
					if (ok) {
						field[i][j] = c;
						break;
					}
				}
			}
		}
		for (int i = 0; i < n0 * n1; ++i) {
			for (int j = 0; j < m0 * m1; ++j) {
				cout << field[i / n0][j / m0];
			}
			cout << "\n";
		}
	}

	return 0;
}