#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;

#define TASK ""
typedef long long ll;
const int INF = (int)1e9 + 23;
const ll LINF = (ll)1e18 + 23;

int solve();

int main() {
	ios_base::sync_with_stdio(0);
#ifdef home
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else 
	cin.tie(0);
	cout.tie(0);
	if (TASK != "") freopen(TASK".in", "r", stdin), freopen(TASK".out", "w", stdout);
#endif
	solve();
	return 0;
}
const int dd = (int)1e6 + 3;

int g[dd], f[dd];

vector<pair<int, int>> v; 
int solve() {
	int n, h; cin >> n >> h;
	for (int i = 0; i < n; i++) {
		int g, f; cin >> g >> f;
		v.push_back({g, f});
	}

	sort(v.begin(), v.end());

	reverse(v.begin(), v.end());

	int maxH = -1;
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		int g = v[i].first, f = v[i].second;
		if (maxH < h + f - 1 && g < h + f - 1) ans += h + f - 1 - max(maxH, g);
		maxH = max(maxH, g);
	}

	cout << ans;


	return 0;
}