#include <bits/stdc++.h>

using namespace std;

vector<int> v[(int)1e5 + 10], arr[(int)1e5 + 10];
int used[(int)1e5 + 10], dp[(int)1e5 + 10][2];
int n, cnt = 0;
map<long long, int> ma;

int get(int x, int y, int z)
{
    if (x > y)
        swap(x, y);
    if (x > z)
        swap(x, z);
    if (y > z)
        swap(y, z);
    long long q = (long long)n * n * x + (long long)y * n + z;
    if (ma.count(q) == 0)
        ma[q] = cnt++;
    //cout << x + 1 << " " << y + 1 << " " << z + 1 << " " << ma[q] << endl;
    return ma[q];
}

void dfs(int v)
{
    //cerr << v << endl;
    used[v] = 1;
    dp[v][1] = -n;
    dp[v][0] = 0;
    for (int u: arr[v])
    {
        if (used[u] == 0)
        {
            dfs(u);
            //cerr << v << endl;
            dp[v][0] += max(dp[u][0], dp[u][1]);
        }
    }
    for (int u: arr[v])
    {
        if (used[u] == 2)
        {
            dp[v][1] = max(dp[v][1], dp[v][0] - max(dp[u][0], dp[u][1]) + dp[u][0] + 1);
        }
    }
    used[v] = 2;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        v[i].push_back((i + 1) % n);
        v[i].push_back((i + n - 1) % n);
    }
    for (int i = 0; i < n - 3; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        v[a].push_back(b);
        v[b].push_back(a);
    }
    for (int i = 0; i < n; i++)
    {
        sort(v[i].begin(), v[i].end());
        int qq = 0, ww = v[i].size();
        while (qq < ww && v[i][qq] < i)
        {
            v[i].push_back(v[i][qq]);
            qq++;
        }
        for (int j = qq; j + 2 < (int)v[i].size(); j++)
        {
            int x = get(i, v[i][j], v[i][j + 1]);
            int y = get(i, v[i][j + 1], v[i][j + 2]);
            arr[x].push_back(y);
            arr[y].push_back(x);
        }
    }
    dfs(0);
    int x = max(dp[0][0], dp[0][1]);
    //cout << x << endl;
    cout << n - 2 - x << endl;
    return 0;
}
