#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#else
#  define cerr __get_ce
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
mt19937 tw(9450189);
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n;
	cin >> n;
	vector<vector<pii>> here(n);
	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		int next = (i + 1) % n;
		here[i].push_back({next, cnt++});
		here[next].push_back({i, cnt++});
	}
	for (int i = 0; i < n - 3; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		here[a].push_back({b, cnt++});
		here[b].push_back({a, cnt++});
	}

	for (int i = 0; i < n; ++i) {
		sort(here[i].begin(), here[i].end());
	}
	vector<bool> used(cnt);
	int face = 0;
	vector<int> edge_face(cnt, -1);
	int bad = -1;
	for (int i = 0; i < n; ++i) {
		for (pii p : here[i]) {
			if (!used[p.ss]) {
				int cur = i, next = p.ff, e = p.ss;
				int l = 0;
				while (!used[e]) {
					// cerr << cur << " ";
					++l;
					used[e] = true;
					edge_face[e] = face;
					int prev = cur;
					cur = next;
					int tmp = find(here[cur].begin(), here[cur].end(), make_pair(prev, e ^ 1)) - here[cur].begin();
					tmp = (tmp - 1 + szof(here[cur])) % szof(here[cur]);
					next = here[cur][tmp].ff;
					e = here[cur][tmp].ss;
				}

				// cerr << endl;
				if (l > 3) {
					bad = face;
				}

				++face;
			}
		}
	}

	vector<vector<int>> tree(face);

	for (int i = 0; i < cnt; i += 2) {
		if (edge_face[i] == bad || edge_face[i + 1] == bad) {
			continue;
		}
		tree[edge_face[i]].push_back(edge_face[i + 1]);
		tree[edge_face[i + 1]].push_back(edge_face[i]);
		// cerr << edge_face[i] << " " << edge_face[i + 1] << endl;
	}

	int r = 0;
	if (bad == 0) {
		++r;
	}

	function<pii(int, int)> dfs = [&](int v, int p) {
		vector<pii> arr;
		for (int to : tree[v]) {
			if (to != p) {
				arr.push_back(dfs(to, v));
			}
		}
		int a = INF, b = INF;
		for (int i = 0; i < 1 << szof(arr); ++i) {
			int s = 0;
			for (int j = 0; j < szof(arr); ++j) {
				if (i & (1 << j)) {
					s += arr[j].ss;
					++s;
				} else {
					s += arr[j].ff;
				}
			}
			if (i) {
				a = min(a, s);
			} else {
				b = min(b, s);
			}
		}
		b = min(b, a);
		return make_pair(a, b);
	};

	auto tmp = dfs(r, r);
	cout << tmp.ff << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
