#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#else
#  define cerr __get_ce
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
mt19937 tw(9450189);
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n, t;
	cin >> n >> t;
	vector<int> arr;
	for (int i = 0; i < n; ++i) {
		int num;
		cin >> num;
		arr.push_back(num);
	}

	int ans = INF;

	for (int i = 0; i < n; ++i) {
		auto cur_arr = arr;
		for (int j = 0; j < t; ++j) {
			int pos = i;
			while (pos > 0 && cur_arr[pos - 1] > cur_arr[pos]) {
				--pos;
			}
			if (pos < i) {
				--cur_arr[pos];
				continue;
			}
			while (pos < n - 1 && cur_arr[pos + 1] > cur_arr[pos]) {
				++pos;
			}
			--cur_arr[pos];
		}

		ans = min(ans, *min_element(cur_arr.begin(), cur_arr.end()));
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
