from sys import argv
from random import *

MAXN = int(argv[1])
MAXX = int(argv[2])
seed(argv[-1])

n = randint(1, MAXN)

MAXX = max(MAXX, (n + 1) // 2)

x = set()
while len(x) < n:
    v = randint(-MAXX, MAXX)
    if v != 0 and v not in x:
        x.add(v)
x = list(x)
x.sort()

y = set()
while len(y) < n:
    v = randint(-MAXX, MAXX)
    if v != 0 and v not in y:
        y.add(v)
y = list(y)
y.sort()

print(n)
print(' '.join(map(str, x)))
print(' '.join(map(str, y)))
