#include<bits\stdc++.h>
using namespace std;

vector<int> min_depth; 
vector<int> ans; 
vector<vector<int>> g;
vector<bool> used;

void dfs(int v, int curd)
{
    used[v] = true;
    if (g[v].size() == 1) {
        min_depth[v] = curd;
        return;
    }
    vector<int> depths;
    for (int u : g[v])
    {
        if (!used[u])
        {
            dfs(u, curd + 1);
            depths.push_back(min_depth[u]);
            min_depth[v] = min(min_depth[v], min_depth[u]);
        }
    }
    sort(depths.begin(), depths.end());
    if (depths.size() >= 2) 
        ans[v] = depths[0] + depths[1] - 2 * curd;
}


int main()
{
    int n;
    cin >> n;
    if (n == 2)
    {
        cout << 1 << endl;
        return 0;
    }

    g.resize(n);
    int root = -1;
    for (int i = 0; i < n - 1; i++)
    {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    root = 0;
    min_depth.assign(n, 2 * n);
    ans.assign(n, -1);
    used.assign(n, false);
    dfs(root, 0);
    int min_ans = 2 * n;
    for (int i = 0; i < n; i++)
    {
        if (ans[i] != -1)
            min_ans = min(min_ans, ans[i]);
    }
    if (min_ans == 2 * n)
        min_ans = -1;
    cout << min_ans << endl;            
    return 0;
}